package org.vraptor.annotations;

import java.lang.annotation.Documented;
import java.lang.annotation.ElementType;
import java.lang.annotation.Retention;
import java.lang.annotation.RetentionPolicy;
import java.lang.annotation.Target;

import org.vraptor.scope.ScopeType;

/**
 * A vraptor's component.
 * 
 * @author Guilherme Silveira
 */
@Target(ElementType.TYPE)
@Retention(RetentionPolicy.RUNTIME)
@Documented
public @interface Component {

	public static final String EMPTY_NAME = "<DEFAULT>";

	/**
	 * Its name
	 * 
	 * @return name
	 */
	// NASTY... default value.
	public String value() default EMPTY_NAME;

	/**
	 * Its scope
	 * 
	 * @return the scope
	 */
	public ScopeType scope() default ScopeType.REQUEST;

}
