package org.vraptor.config;

import java.io.File;

import org.apache.log4j.Logger;
import org.vraptor.component.ComponentManager;
import org.vraptor.component.InvalidComponentException;

class BasePackageComponentLoader {

	private static final Logger LOG = Logger.getLogger(BasePackageComponentLoader.class);

	private ComponentManager manager;

	BasePackageComponentLoader(ComponentManager manager) {
		this.manager = manager;
	}

	void loadLogics(File dir, String pkg) {
		File logicDir = new File(dir, "logic");
		if (logicDir.exists() && logicDir.isDirectory()) {
			loadComponents(logicDir, pkg + ".logic.");
		} else {
			LOG.debug("Logic path not found/is not a directory: " + logicDir.getAbsolutePath());
		}
	}

	private void loadComponents(File dir, String currentPkg) {
		for (File file : dir.listFiles()) {
			if (file.isDirectory()) {
				loadComponents(file, currentPkg + file.getName() + ".");
			} else if (file.isFile() && file.getName().endsWith(".class")) {
				try {
					String name = file.getName();
					name = name.substring(0, name.length() - 6);
					manager.register(currentPkg + name);
				} catch (InvalidComponentException e) {
					LOG.error("Unable to config some component", e);
				}
			}
		}
	}

}
