package org.vraptor.config.xml;

import org.apache.log4j.Logger;
import org.vraptor.config.BasePackageConfig;

import com.thoughtworks.xstream.converters.Converter;
import com.thoughtworks.xstream.converters.MarshallingContext;
import com.thoughtworks.xstream.converters.UnmarshallingContext;
import com.thoughtworks.xstream.io.HierarchicalStreamReader;
import com.thoughtworks.xstream.io.HierarchicalStreamWriter;

/**
 * A base package xml converter.
 * 
 * @author Guilherme Silveira
 */
public class BasePackageConverter implements Converter {

	private static final Logger LOG = Logger
			.getLogger(BasePackageConverter.class);

	public boolean canConvert(Class clazz) {
		return clazz.equals(BasePackageConfig.class);
	}

	public void marshal(Object value, HierarchicalStreamWriter writer,
			MarshallingContext context) {
		BasePackageConfig object = (BasePackageConfig) value;
		writer.setValue(object.getPackage());
	}

	public Object unmarshal(HierarchicalStreamReader reader,
			UnmarshallingContext context) {
		String pkg = reader.getValue();
		LOG.debug("found configbasepackage xml item for base package " + pkg);
		if (pkg == null) {
			throw new NullPointerException();
		}
		return new BasePackageConfig(pkg.trim());
	}

}
