package org.vraptor.interceptor;

import org.apache.log4j.Logger;
import org.vraptor.Interceptor;
import org.vraptor.LogicException;
import org.vraptor.LogicFlow;
import org.vraptor.component.ComponentType;
import org.vraptor.core.VRaptorExecution;
import org.vraptor.introspector.Introspector;
import org.vraptor.reflection.GettingException;
import org.vraptor.view.ViewException;

/**
 * Outjects.
 * 
 * @author Guilherme Silveira
 */
public class OutjectionInterceptor implements Interceptor {

	private static final Logger LOG = Logger
			.getLogger(OutjectionInterceptor.class);

	private VRaptorExecution engine;

	private ComponentType type;

	public OutjectionInterceptor(VRaptorExecution engine,
			ComponentType componentClass) {
		this.engine = engine;
		this.type = componentClass;
	}

	public void intercept(LogicFlow flow) throws LogicException, ViewException {

		Object component = flow.getLogicRequest().getLogicContext()
				.getAttribute(ComponentLookupInterceptor.CURRENT_COMPONENT);

		LOG.debug("ready to outject");

		try {
			Introspector introspector = engine.getController()
					.getIntrospector();
			introspector.outject(type.getOutAnnotations(), component, flow
					.getLogicRequest());
		} catch (GettingException e) {
			throw new LogicException(e.getMessage(), e);
		}

		flow.execute();

	}

}
