package org.vraptor.interceptor;

import org.vraptor.Interceptor;
import org.vraptor.LogicException;
import org.vraptor.LogicFlow;
import org.vraptor.component.LogicMethod;
import org.vraptor.scope.DefaultLogicRequest;
import org.vraptor.url.SimpleLogicRequest;
import org.vraptor.view.ViewException;

public class RegisterAttributesInteceptor implements Interceptor {

	public static final String LOGIC_METHOD_KEY = "org.vraptor.logic_method";

	private LogicMethod method;

	public RegisterAttributesInteceptor(SimpleLogicRequest request,
			LogicMethod method) {
		this.method = method;
	}

	public void intercept(LogicFlow flow) throws LogicException, ViewException {
		DefaultLogicRequest req = (DefaultLogicRequest) flow.getLogicRequest();
		flow.getLogicRequest().getLogicContext().setAttribute(LOGIC_METHOD_KEY,
				method.getMetadata().getMethod());
		flow.getLogicRequest().getRequestContext().setAttribute("request", req.getRequest());
		flow.getLogicRequest().getRequestContext().setAttribute("response", req.getResponse());
		flow.getLogicRequest().getRequestContext().setAttribute("application", req.getResponse());
		flow.getLogicRequest().getRequestContext().setAttribute("session", req.getRequest().getSession());
		
		flow.execute();
	}
}
