package org.vraptor.interceptor;

import org.apache.log4j.Logger;
import org.vraptor.Interceptor;
import org.vraptor.LogicException;
import org.vraptor.LogicFlow;
import org.vraptor.component.LogicMethod;
import org.vraptor.url.SimpleLogicRequest;
import org.vraptor.view.ViewException;
import org.vraptor.view.ViewManager;

public class ViewInterceptor implements Interceptor {

	private static final Logger LOG = Logger.getLogger(ViewInterceptor.class);

	private LogicMethod logicMethod;

	private ViewManager viewManager;

	public ViewInterceptor(ViewManager viewManager, LogicMethod logicMethod) {
		this.viewManager = viewManager;
		this.logicMethod = logicMethod;
	}

	public void intercept(LogicFlow flow) throws LogicException, ViewException {

		SimpleLogicRequest request = (SimpleLogicRequest) flow
				.getLogicRequest();

		String result = (String) request.getRequestContext().getAttribute(
				ExecuteLogicInterceptor.RESULT_KEY);

		if (this.logicMethod.shouldRedirect()) {
			LOG.debug("last interception: ready to redirect with result "
					+ result);
			viewManager.forward(request, result, request.getRequest(), request
					.getResponse());
		} else {
			LOG.debug("No view");
		}

	}
}
